upnp.h File Reference
libpurple

Universal Plug N Play API. More...

Go to the source code of this file.

## Typedefs

typedef struct _UPnPMappingAddRemove | UPnPMappingAddRemove

## UPnP API

typedef void(* | PurpleUPnPCallback) (gboolean success, gpointer data)
void | purple_upnp_init (void)
| Initialize UPnP.
void | purple_upnp_discover (PurpleUPnPCallback cb, gpointer cb_data)
| Sends a discovery request to search for a UPnP enabled IGD that contains the WANIPConnection service that will allow us to recieve the public IP address of the IGD, and control it for forwarding ports. More...
const gchar * | purple_upnp_get_public_ip (void)
| Gets the IP address from a UPnP enabled IGD that sits on the local network, so when getting the network IP, instead of returning the local network IP, the public IP is retrieved. More...
void | purple_upnp_cancel_port_mapping (UPnPMappingAddRemove *mapping_data)
| Cancel a pending port mapping request initiated with either purple_upnp_set_port_mapping() or purple_upnp_remove_port_mapping(). More...
UPnPMappingAddRemove * | purple_upnp_set_port_mapping (unsigned short portmap, const gchar *protocol, PurpleUPnPCallback cb, gpointer cb_data)
| Maps Ports in a UPnP enabled IGD that sits on the local network to this purple client. More...
UPnPMappingAddRemove * | purple_upnp_remove_port_mapping (unsigned short portmap, const gchar *protocol, PurpleUPnPCallback cb, gpointer cb_data)
| Deletes a port mapping in a UPnP enabled IGD that sits on the local network to this purple client. More...

## Detailed Description

Universal Plug N Play API.

Definition in file upnp.h.

## Function Documentation

## purple_upnp_cancel_port_mapping()

void purple_upnp_cancel_port_mapping | ( | UPnPMappingAddRemove * | mapping_data | ) |

Cancel a pending port mapping request initiated with either purple_upnp_set_port_mapping() or purple_upnp_remove_port_mapping().

Parameters

  mapping_data | The data returned when you initiated the UPnP mapping request.

## purple_upnp_discover()

void purple_upnp_discover | ( | PurpleUPnPCallback | cb,
|  | gpointer | cb_data
| ) |  |

Sends a discovery request to search for a UPnP enabled IGD that contains the WANIPConnection service that will allow us to recieve the public IP address of the IGD, and control it for forwarding ports.

The result will be cached for further use.

Parameters

  cb | an optional callback function to be notified when the UPnP discovery is complete
  cb_data | Extra data to be passed to the callback

## purple_upnp_get_public_ip()

const gchar* purple_upnp_get_public_ip | ( | void |  | ) |

Gets the IP address from a UPnP enabled IGD that sits on the local network, so when getting the network IP, instead of returning the local network IP, the public IP is retrieved.

This is a cached value from the time of the UPnP discovery.

Returns
  The IP address of the network, or NULL if something went wrong

## purple_upnp_remove_port_mapping()

UPnPMappingAddRemove* purple_upnp_remove_port_mapping | ( | unsigned short | portmap,
|  | const gchar * | protocol,
|  | PurpleUPnPCallback | cb,
|  | gpointer | cb_data
| ) |  |

Deletes a port mapping in a UPnP enabled IGD that sits on the local network to this purple client.

Essentially, this function takes care of deleting the port forwarding after they have completed a connection so another client on the local network can take advantage of the port forwarding

Parameters

  portmap | The port to delete the mapping for
  protocol | The protocol to map to. Either "TCP" or "UDP"
  cb | an optional callback function to be notified when the mapping removal is complete
  cb_data | Extra data to be passed to the callback

Returns
  Data which can be passed to purple_upnp_port_mapping_cancel() to cancel

## purple_upnp_set_port_mapping()

UPnPMappingAddRemove* purple_upnp_set_port_mapping | ( | unsigned short | portmap,
|  | const gchar * | protocol,
|  | PurpleUPnPCallback | cb,
|  | gpointer | cb_data
| ) |  |

Maps Ports in a UPnP enabled IGD that sits on the local network to this purple client.

Essentially, this function takes care of the port forwarding so things like file transfers can work behind NAT firewalls

Parameters

  portmap | The port to map to this client
  protocol | The protocol to map, either "TCP" or "UDP"
  cb | an optional callback function to be notified when the mapping addition is complete
  cb_data | Extra data to be passed to the callback

Returns
  Data which can be passed to purple_upnp_port_mapping_cancel() to cancel